import offers
import cfg
import sys
import os

cfg = cfg.readCfg()
ofs = offers.readOffers()

def generate_projects(args):
    if len(args) < 3:
        print "Usage: generate_opt_projects <template path> <output_folder>"
        return

    template_path = args[1]
    out_path = args[2]

    if not os.path.exists(out_path):
        os.makedirs(out_path)

    template = ""

    with open(template_path) as f:
        template = f.read()

    cmd = ""
    run_opt_cmdline = "C:\Gehtsoft\IndicoreSDK3\ConsoleOptimizer.exe %1.opt.xml /v /o %1.stat"

    for offer in ofs:
        m = {}
        for k, v in offer.iteritems():
            m["${" + k + "}"] = v
        for k, v in cfg.iteritems():
            m["${" + k + "}"] = v

        offer_cfg = template
        for k,v  in m.iteritems():
            offer_cfg = offer_cfg.replace(k, v)

        instr = offer["instrument"]
        instr = instr.replace("/", "_")
        name = template_path +"_" +  instr
        outname = out_path + "/" + name + ".opt.xml"
        fo = open(outname, "w")
        fo.write(offer_cfg)
        fo.close()
        cmd_ccy = run_opt_cmdline.replace("%1", name)
        cmd += cmd_ccy
        cmd += "\n"

    fc = open(out_path + "/run_opt.bat", "w")
    fc.write(cmd)
    fc.close()

generate_projects(sys.argv)